<?php

/*
 * PuzzleApp
 * Webemyos
 * Jérôme Oliva
 * GNU Licence
 */

namespace Apps\Lang\Helper;

use Core\Entity\Entity\Argument;
use Core\Entity\Langs\Langs;
use Core\Entity\Langs\LangsCode;
use Core\Entity\Langs\LangsElement;

class ElementHelper
{
    /**
     * Supprime un element
     * @param type $core
     * @param type $elementId
     */
    public static function RemoveElement($core, $elementId)
    {
        //Suppression des enfants
        $request = "DELETE FROM ee_lang_element WHERE CodeId = " . $elementId;
        $core->Db->Execute($request);
 
        $request = "DELETE FROM ee_lang_code WHERE Id = " . $elementId;
        $core->Db->Execute($request);

        echo "Suppression de l'element ." . $elementId;
    }
    
    /*
     * Met a jour un element dans la langue courante
     */
    public static function UpdateElement($core, $idElement, $value)
    {
        //Recuperation de l'identifiant de la langue
        $Lang = new Langs($core);
        $Lang->AddArgument(new Argument("Core\Entity\Langs\Langs","Code", EQUAL, $core->GetLang()));
        $Langs=$Lang->GetByArg();
               
        $element = self::GetElementByCode($core, $idElement, $Langs[0]->IdEntite);

        if($element == null)
        {
            echo "Ajout de l'element";

            //Update ou insert l'element
            $element = new LangsElement($core);
            $element->CodeId->Value = $idElement;
            $element->LangId->Value = $Langs[0]->IdEntite;
        }
        else
        {
            echo "Mise à jour de l'élement => ".$idElement;
        }
        $element->Libelle->Value = $value;

        $element->Save();

        
    }

    public static function GetElementByCode($core, $idElement, $idLangue)
    {
        $element = new LangsElement($core);
        $element->AddArgument(new Argument("Core\Entity\Langs\LangsElement","CodeId", EQUAL, $idElement ));
        $element->AddArgument(new Argument("Core\Entity\Langs\LangsElement","LangId", EQUAL, $idLangue ));
        
        $elements = $element->GetByArg();

        if(count($element) > 0)
        {
            return $elements[0];
        }
        else
        {
            //Suppression des doublons
            return null;
        }
    }
}

