var Animation = function(){};

/**
 * Affiche un control
 * @param {*} controlId 
 */
Animation.Show = function(query)
{
 var show = new Show();
     show.query = query;
     show.Run();
};

/**
 * Hide à control
 * @param {*} controlId 
 * @param {*} speed 
 */
Animation.Hide = function(query, speed)
{
 var hide = new Hide();
     hide.query = query;
     hide.Run();
};

/**
 * Open à control
 * @param {*} controlId 
 * @param {*} speed 
 * @param {*} width 
 * @param {*} height 
 */
Animation.Open = function(controlId, speed, width, height)
{
    var control = document.getElementById(controlId);
    
    var open = new Open();
        open.control = control;
        open.Run(speed, width, height);
};

/**
 * FadeOut à control
 * @param {*} controlId 
 * @param {*} speed 
 */
Animation.FadeOut = function(controlId, speed, callBack)
{
    var control = document.getElementById(controlId);
    
    var fadeOut = new FadeOut();
    fadeOut.control = control;
    fadeOut.callBack = callBack;
    fadeOut.Run(speed);
};

/**
 * FadeIn à control
 * @param {*} controlId 
 * @param {*} speed 
 */
Animation.FadeIn = function(controlId, speed)
{
    var control = document.getElementById(controlId);
    
    var fadeIn = new FadeIn();
    fadeIn.control = control;
    fadeIn.Run(speed);
};

/**
 * Affiche une notification
 */
Animation.Notify = function(message, control, autoClose)
{
    var notification = new Notification();
        notification.AutoClose = autoClose;    
        notification.Notify(message, control);
};

/**
 * SnavkBarr de confirmation
 * @param {*} message 
 * @param {*} callBack 
 */
Animation.Confirm = function(message, callBackYes){

    var notification = new Notification();
        notification.Type = 'Confirm';
        notification.Notify(message, null, callBackYes);
};

/***
 * Ajout d'un viewer sur les images
 * @returns {undefined}
 */
Animation.AddViewer = function(control)
{
    var viewer = new Viewer();
        viewer.AddOnControl(control);
};

/**
 * Gestion des carroussel
 * @param {type} control
 * @returns {undefined}
 */
Animation.Caroussel = function(control)
{
    var caroussel = new Caroussel(control);
        caroussel.Start();  
};

/**
 * Transforme des div en présenation vers des control
 * @param {*} contro 
 */
Animation.Tuto = function(control)
{
    var tuto = new Tuto(control);
        tuto.Start();
};

/***
 * Ajoute une class css
 * @param {type} control
 * @param {type} className
 * @returns {undefined}
 */
Animation.AddClass = function(controlId, className)
{
     var control = document.getElementById(controlId);
     control.className = control.className + " " +  className;
};

/**
 * Supprimes une class Css
 * @param {*} controlId 
 * @param {*} className 
 */
Animation.RemoveClass = function(controlId, className)
{
     var control = document.getElementById(controlId);
     control.className = control.className.replace(className, "");
};

/**
 * Ajoute un loading sur un control
 * @param {*} controlId 
 */
Animation.AddLoading = function(controlId)
{
    var loading = new Loading();
        loading.ShowOn(controlId)
};

/**
 * Supprime un loading d'un control
 */
Animation.RemoveLoading = function(controlId)
{
    var loading = new Loading();
        loading.RemoveOn(controlId)
};


Animation.ToolTip = function(controlId){

    var toolTip = new ToolTip(controlId);
    
    Event.AddById(controlId, "mouseenter", function(){
        toolTip.Open();
    });
    
    Event.AddById(controlId, "mouseout", function(){
        toolTip.Close();
    });
};