var Form = new Form();

/***
 * Gestionnaire de formulaire
 * @returns {Form}
 */
function Form()
{
    /**
     * Vérifie chaque champ du formulaire
     * @param {type} formId
     * @returns 
     */
    this.IsValid = function(formId)
    {
        this.formId = formId;
        var currentForm = document.getElementById( this.formId);
        this.currentForm = currentForm;
        
        var controls = currentForm.getElementsByTagName("input");
        var select = currentForm.getElementsByTagName("select");
        var uploaderDiv = currentForm.getElementsByClassName("uploaderDiv");
        
        var errors = 0;
        
        //Validation des input standards
        for(var i = 0; i <controls.length;  i++ ){
            if(!this.VerifyControl(controls[i]))
            {
                errors+= 1;    
            }
        }
        
        /**
         * Validation des selection
         */
        for(var i = 0; i <select.length;  i++ ){
            if(!this.VerifyControl(select[i]))
            {
                errors+= 1;    
            }
        }
     
       for(var i =0; i < uploaderDiv.length ; i++){
            if(!this.VerifiyUpload(uploaderDiv[i]))
            {
                errors+= 1;    
            }
       }

        return (errors == 0);
    };
    
    /**
     * Vérifie le control selon ces validators
     * @returns 
     */
    this.VerifyControl = function(control){
        
        if(control.dataset.validator == undefined){
            return true;
        }
        
        var validators = control.dataset.validator.split("|");
        
        this.RemoveErrorMessage(control);
        
         //Enfin on vérifie le type
            if(!this.VerifyType(control)){
                this.AddErrorMessage(control, "IncorrectFormat");
                return false;
            }
            
        if(validators != "undefined"){
            
            //On verifie chaque validator
            for(var j = 0;j < validators.length ; j++){
                
               if(validators[j] == "Required"){
                        
                    if(control.disabled == false && control.value == "" ){
                        this.AddErrorMessage(control, "Required");
                        return false;
                    }
                }
                else{
                   if(!eval(validators[j]+".Verify(control, this)")){
                        return false;
                    }
                }
            }
           
        }
        else
        {
            return true;
        }
        
        return true;
    };
    
    /**
     * Vérification des uploader
     * Si les fichiers sont obligatoire ou pas
     */
    this.VerifiyUpload = function(control){

        var validators = control.getElementsByClassName("validators");
        var img = control.parentNode.getElementsByClassName("uplloadImage");

        //Suppression des message d'erreurs           
        this.RemoveErrorMessage(control);

        if(validators[0].value.indexOf("Required") > - 1 && img.length == 0){

            this.AddErrorMessage(control, "Required");

           return false;
        } else {
            return true;
        }
    };

    /***
     * Ajout un message d'erreur en dessous du control
     * @returns {undefined}
     */
    this.AddErrorMessage = function(control, message){
        
        var container = control.parentNode;

        var divError = document.createElement("div");
            divError.className = "errorControl";
            divError.innerHTML = message;
        
        container.appendChild(divError);  
    };
    
    /***
     * Remove message Error
     * @param {type} control
     * @param {type} message
     * @returns {undefined}
     */
    this.RemoveErrorMessage = function(control){
        
        var container = control.parentNode;
        var errorControl = container.getElementsByClassName("errorControl");
        
        if(errorControl.length > 0 ){
            container.removeChild(errorControl[0]);
        }
    };
    
    /***
     * Y t'il d'autre erreur
     * @returns {undefined}
     */
    this.HaveError = function(){
         var currentForm = document.getElementById( this.formId);
         var errors = currentForm.getElementsByClassName("errorControl");
         return (errors.length == 0);
    };
    
    /***
     * Vérifie le contenu selon le type
     * @returns {undefined}
     */
    this.VerifyType = function(control){
        
        //TODO RAJOUTER TOUS LES TYPE
        switch(control.type)
        {
            case "email" : 
             return EmailBox.Verify(control.value);
            break;
        }
        
        return true;
    };

    /**
     * Serialize les controles remplies
     * Pas besoin de vérification cela a été fait avant
     * @param {*} formId 
     */
    this.Serialize =function(formId)
    {
        var data = "";
        currentForm = document.getElementById(formId);

        //Input standard
        var inputs = currentForm.getElementsByTagName("input");

        for(var i =0; i < inputs.length ;i ++)
        {
            if(inputs[i].type == "button")
            {}
            else if(inputs[i].type == "checkbox")
            {
                if(inputs[i].checked == true){
                    data += "&" + inputs[i].name + "=" + inputs[i].value;
                }
            } 

            else if(inputs[i].type == "radio")
            {
                if(inputs[i].checked == true){
                    data += "&" + inputs[i].name + "=" + inputs[i].value;
                }
            } 
            else if(inputs[i].value != "")
            {
                data += "&" + inputs[i].name + "=" + inputs[i].value;
            }
        }

        //Select
        var selects = currentForm.getElementsByTagName("select");

        for(var i =0; i < selects.length ;i ++)
        {
            if(selects[i].value != "")
            {
                data += "&" + selects[i].name + "=" + selects[i].value;
            }
        }

        //upload
        var uploaderDiv = currentForm.getElementsByClassName("uploaderDiv");

        for(var i =0; i < uploaderDiv.length ; i++)
        {
            var imgs = Array();
            var uplloadImage = uploaderDiv[i].parentNode.getElementsByClassName("uplloadImage");

            for(var j = 0; j < uplloadImage.length; j++)
            {
                   var img =  uplloadImage[j].getElementsByTagName("img");

                   for(var k=0; k < img.length ; k++)
                    {
                        imgs.push(img[k].src); 
                    }
                }

            data += "&" + uploaderDiv[i].id + "="+imgs.join(",");
       }

        return data;
    };

    /**
     * Affiche un message d'erreur
     */
    this.RenderError = function(formId, message)
    {
        var form = document.getElementById(formId);
            error = form.getElementsByClassName("error");

            error[0].innerHTML = message.join('<br/>');
    };
};