<?php

/*
 * PuzzleApp
 * Webemyos
 * Jérôme Oliva
 * GNU Licence
 */

namespace Core\Control\Form;

use Core\Control\IControl;
use Core\Control\Control;
use Core\Control\Upload\Upload;

use Core\View\View;
use Core\View\ElementView;

use Core\Core\Core;

class Form extends Control implements IControl
{
    protected $Controls = array();
    protected $View;
    protected $Data ;
    public $errors = array(); 
    
    /**
     * 
     * @param type $name
     */
    function __construct($name, $data = "")
    {
        //Version
        $this->Version ="2.0.1.0";

        $this->Id=$name;
        $this->Name=$name;
        $this->Core = Core::getInstance();
        $this->Data = $data;
    }

    /**
     * Définie la vue utilisé
     */
    function SetView($view)
    {
        $this->View = $view;
    }

    /**
     * Ajoute un control
     */
    function Add($control)
    {
        $this->Controls[$control["Id"]] = $control;
    }

    /**
     * Définie l'action
     */
    function SetAction()
    {
        
    }
    
    /**
     * Génére la balise Form ouvrante
     */
    function RenderOpen()
    {
        $html = "<form id='".$this->Id."' >";
        
        return $html;
    }
    
     /**
     * Génére la balise Form ouvrante
     */
    function RenderClose()
    {
        $html = "</form>";
        
        return $html;
    }
    
    /**
     * Génére la balise Form ouvrante
     */
    function RenderError()
    {
        $html = "<div class='error'></div>";
        
        return $html;
    }
    
    /**
     * Génére la balise Form ouvrante
     */
    function RenderSuccess()
    {
        $html = "<div class='success'></div>";
        
        return $html;
    }
    
    function RenderControl($html)
    {
        
        //Remplacement des proprietes
        $pattern = "`{{form->Render\((.+)\)}}`";
        preg_match_all($pattern, $html, $macthes);
        $i = 0;

      //  echo "<br/><br/>";
       //  echo "<pre>";       
       // var_dump($macthes);
        foreach($macthes[0] as $match)
        { 
           // echo $match;
           $name = $macthes[1][$i];
          
            if(isset($this->Controls[$name]))
            {
                $type =  $this->Controls[$name]["Type"];
                

                if($type == "Upload"){

                    //$app, $id ="", $callBack ="", $action = false, $idUpload ="fileToUpload"
                    $control = new Upload($this->Controls[$name]["App"],
                                          $this->Controls[$name]["Id"],
                                          "",
                                          $this->Controls[$name]["Method"],
                                          $this->Controls[$name]["Id"]  . "fileToUpload"
                                        );
                } else {

                $className = "Core\\Control\\" . $type ."\\".$type ;
                $control = new $className($this->Controls[$name]["Id"], $this->Core);
                $control->Id = $this->Controls[$name]["Id"];
                
                }

                if(isset($this->Controls[$name]["Name"])){
                    $control->Name = $this->Controls[$name]["Name"];
                }
                 if(isset($this->Controls[$name]["Checked"])){
                    $control->Checked = $this->Controls[$name]["Checked"];
                }
                
                if(isset($this->Controls[$name]["Value"])){
                    $control->Value = $this->Controls[$name]["Value"];
                }
                if(isset($this->Controls[$name]["CssClass"])){
                    $control->CssClass = $this->Controls[$name]["CssClass"];
                }

                //EntityListBox
                if(isset($this->Controls[$name]["Entity"])){
                    $control->Entity = $this->Controls[$name]["Entity"];

                    if(isset($this->Controls[$name]["Field"]))
                    {   
                        $control->AddField($this->Controls[$name]["Field"]);
                    }
                    if(isset($this->Controls[$name]["Values"]  ))
                    {
                        foreach($this->Controls[$name]["Values"] as $key => $value)
                        {
                            $control->ListBox->Add($this->Core->GetCode($value),$key);
                        }
                    }
                }

                if(isset($this->Controls[$name]["Attributs"]))
                {
                    foreach($this->Controls[$name]["Attributs"] as $key => $value)
                    {
                        $control->AddAttribute($key, $value);
                    }
                }
                
                if(isset($this->Controls[$name]["Validators"])){
                    $control->Validators = implode("|",$this->Controls[$name]["Validators"]) ;
                }
                
                if(isset($this->Controls[$name]["Values"])){
                     $control->Options = $this->Controls[$name]["Values"];
                }
                
              
                
                $html = str_replace($match, $control->Show(), $html);
            }        
//$html .= $match;
            
            $i++;
        }
        
        return $html;
    }
    /***
     * Génére le html du formulaire
     */
    function Render()
    {
        $view = new View($this->View);
        $view->AddElement($this);
       
        return $view->Render();
    }

    /***
     * Valide ces données selon les Controles Ajoutés
     */
    function Validate($data = "")
    {
        foreach($this->Controls as $control)
        {
            $validators = $control["Validators"] ;


            foreach($validators as $validator)
            {

                switch($validator){
                    case "Required";

                        if($control["Type"] == "Upload"){
                            //dvUpload-imageToUploadFacefileToUpload
                            $controlName = "dvUpload-".$control['Id']."fileToUpload";
                        
                            if(!isset($data[$controlName]) || $data[$controlName] == "" )
                            {
                                $this->errors[] = $control['Id'] . " " . $this->Core->GetCode("Required");
                            }
                        }
                        else  if(!isset($data[$control['Id']]) || $data[$control['Id']] == "" )
                        {
                            $this->errors[] = $control['Id'] . " " . $this->Core->GetCode("Required");
                        }
                    break;
                }
            }
        }
        
        if(count($this->errors) > 0 )
        {
            return false;
        }
        else
        {
            return true;
        };      
    }
    
    /***
     * Retourne les success au format JSON
     */
    function Success()
    {
        return json_encode(array("statut"=> "Success"));
    }
    
    /***
     * Retournes les erreurs au format JSON
     */
    function Error()
    {
        return json_encode(array("statut"=> "Error", "message" => $this->errors));
    }
    
    /**
     * Retourne une des variable
     */
    function Get($name)
    {
        return $this->Data[$name];
    }
    
}
?>